import pyspark
# Note we need pyspark.sql to get SparkSession
from pyspark.sql import SparkSession
from pyspark.streaming import StreamingContext
from pyspark.streaming.kafka import KafkaUtils
import os
import json
spark = SparkSession.builder.appName("PySparkStreamingKafka").getOrCreate()
sc=spark.sparkContext

# turn off INFO and WARN message, if things don't work
# comment out the following line
sc.setLogLevel("ERROR")
# set up streaming context to check data every 30 seconds
ssc = StreamingContext(sc,30)
# Here is where the stream is created, topic = "connect-test1" 
kafkaStream = KafkaUtils.createStream(ssc, '0.0.0.0:2181', 'spark-streaming', {'monkeys':1})
# map all lines, note you can include other processing here
lines = kafkaStream.map(lambda x: x[1])
# use JSON "pretty print to print the lines (max 10)
lines.pprint()
# Count the lines in this batch
lines.count().map(lambda x:'Messages in this batch: %s' % x).pprint()
# save to HDFS as files
kafkaStream.saveAsTextFiles('hdfs://localhost:9000/user/hands-on/Kafka-Streaming/monkeys-activity')
# start the streaming 
ssc.start()
# Run until interrupted
ssc.awaitTermination()
