import io
import json
from kafka import KafkaConsumer
from kafka import TopicPartition
from IPython.display import display
import datetime

servers = ['localhost:9092']
def deserializer(v):
	return json.loads(v.decode('utf-8'))

topic = "weather"
verbose= "xyes"

# Set the start and end index for all partions
start = 11 
end = 14

# Select and read a specific offset 
#
# NOTE: Overrides the fetch offsets that the consumer will use on the 
# next poll(), if specified (i.e. earliest, 'lastest'). If this API is invoked 
# for the same partition more than once, the latest offset will be used on 
# the next poll().
# You may lose data if this API is arbitrarily used in the middle of consumption 
# to reset the fetch offsets.

# Will not work for messages that do not have a key value, i.e that is
# messages created with python w-producer2.py
# set up consumer and add 5 second time out to ensure return if no records.

consumer = KafkaConsumer(bootstrap_servers=servers, consumer_timeout_ms=5000,
                         value_deserializer=deserializer)

# For real installations, there will be multiple partions
# for a topic. Cycle through all partions.
topic_partitions = consumer.partitions_for_topic(topic)
for part in topic_partitions:
	print("Checking partition: %d" % part)
	partition = TopicPartition('weather', part)
	# Change these based on the partion(s) you want to consume 
	consumer.assign([partition])
	consumer.seek(partition, start)
	for message in consumer:
		if message.offset > end:
        		break
		if message.key is not None:
			key=message.key.decode("utf-8")
		else:
			key='NO KEY'
		# use message.value to print the full contents of the message
		time=datetime.datetime.fromtimestamp(message.timestamp/1000.0)
		print("  Partition: %s Message Offset %d " % (part, message.offset))
		print ("    Time=%s: Zipcode %s" % (time, key))
exit()

