
import sys
import os
import shutil
import time
from json import dumps
from kafka import KafkaProducer
from noaa_sdk import NOAA

servers = ['localhost:9092']
def serializer(v):
	return  dumps(v).encode('utf-8')
def key(k):
	return bytes(k,'utf-8')
topic = 'weather'
verbose = 'xyes'
# Set US zipcode (NYC, Chicago, LA)
zipcodes = ["10001", "60007", "90006"]
producer = KafkaProducer(bootstrap_servers=servers, value_serializer=serializer)

n = NOAA()
for code in zipcodes:
	# Can use forecast, forecastHourly, forecastGridData for "type"
	noaa_result = n.get_forecasts(code, 'US', type='forecast')

	# Set verbose to print out data
	if verbose == 'yes':
		for i in noaa_result:
			print(i)
	# send result to Kafka, include the zip code as the key (convert to bytes)
	producer.send(topic, value=noaa_result, key=key(code))

	# using "flush" effectivly makes the producer synchronous
	# it does not return until message is written to Kafka
	producer.flush()
